import 'package:lokalise_flutter_sdk/otav2/data/persistence/bundle_persistence.dart';
import 'package:lokalise_flutter_sdk/otav2/data/persistence/entities/bundle_entity.dart';
import 'package:lokalise_flutter_sdk/otav2/domain/models/bundle.dart';

class LocalBundleRepository {
  final BundlePersistence _persistence;

  LocalBundleRepository({required BundlePersistence persistence})
      : _persistence = persistence;

  Bundle? getBundle() {
    final bundleEntity = _persistence.get();
    if (bundleEntity == null) {
      return null;
    }

    return bundleEntity.toBundle();
  }

  Future<bool> saveBundle({required Bundle bundle}) {
    return _persistence.save(
      bundleEntity: BundleEntity.fromBundle(bundle: bundle),
    );
  }

  Future<bool> removeBundle() {
    return _persistence.remove();
  }
}
