import 'package:lokalise_flutter_sdk/otav2/domain/models/enums/translation_type.dart';
import 'package:lokalise_flutter_sdk/otav2/domain/models/json_serializable.dart';
import 'package:lokalise_flutter_sdk/otav2/domain/models/translation/plural_translation.dart';
import 'package:lokalise_flutter_sdk/otav2/domain/models/translation/simple_translation.dart';

abstract class Translation implements JsonSerializable {
  final TranslationType type;

  @Deprecated('to be backwards compatible, it will be removed in the future')
  final String original;

  Translation({required this.type, required this.original});

  static Translation? fromJson({required Map<String, dynamic> json}) {
    if (!json.containsKey('type')) {
      return null;
    }

    final type = TranslationType.values.byName(json['type']);
    switch (type) {
      case TranslationType.simple:
        return SimpleTranslation.fromJson(json: json);
      case TranslationType.plural:
        return PluralTranslation.fromJson(json: json);
      default:
        return null;
    }
  }

  String? getTranslation(Map<String, Object> args);
}
